MODULE	'exec/lists',
			'exec/libraries',
			'exec/interrupts',
			'graphics/monitor'

OBJECT GfxBase
	LibNode:Library,
	ActiView:PTR TO View,
	copinit:PTR TO CopInit,	/* ptr to copper start up list */
	cia:PTR TO LONG,			/* for 8520 resource use */
	blitter:PTR TO LONG,		/* for future blitter resource use */
	LOFlist:PTR TO UWORD,
	SHFlist:PTR TO UWORD,
	blthd:PTR TO bltnode,
	blttl:PTR TO bltnode,
	bsblthd:PTR TO bltnode,
	bsblttl:PTR TO bltnode,
	vbsrv:Interupt,
	timsrv:Interupt,
	bltsrv:Interupt,
	TextFonts:List,
	DefaultFont:PTR TO TextFont,
	Modes:UWORD,			/* copy of current first bplcon0 */
	VBlank:BYTE,
	Debug:BYTE,
	BeamSync:WORD,
	system_bplcon0:WORD,		/* it is ored into each bplcon0 for display */
	SpriteReserved:UBYTE,
	bytereserved:UBYTE,
	Flags:UWORD,
	BlitLock:WORD,
	BlitNest:WORD,

	struct	List BlitWaitQ;
	struct	Task *BlitOwner;
	struct	List TOF_WaitQ;
	UWORD	DisplayFlags;		/* NTSC PAL GENLOC etc*/
					/* flags initialized at power on */
	struct	SimpleSprite **SimpleSprites;
	UWORD	MaxDisplayRow;		/* hardware stuff, do not use */
	UWORD	MaxDisplayColumn;	/* hardware stuff, do not use */
	UWORD	NormalDisplayRows;
	UWORD	NormalDisplayColumns;
	/* the following are for standard non interlace, 1/2 wb width */
	UWORD	NormalDPMX;		/* Dots per meter on display */
	UWORD	NormalDPMY;		/* Dots per meter on display */
	struct	SignalSemaphore *LastChanceMemory;
	UWORD	*LCMptr;
	UWORD	MicrosPerLine;		/* 256 time usec/line */
	UWORD	MinDisplayColumn;
	UBYTE	ChipRevBits0;
	UBYTE	MemType;
	UBYTE	crb_reserved[4];
	UWORD	monitor_id;
	ULONG	hedley[8];
	ULONG	hedley_sprites[8];	/* sprite ptrs for intuition mouse */
	ULONG	hedley_sprites1[8];	/* sprite ptrs for intuition mouse */
	WORD	hedley_count;
	UWORD	hedley_flags;
	WORD	hedley_tmp;
	LONG	*hash_table;
	UWORD	current_tot_rows;
	UWORD	current_tot_cclks;
	UBYTE	hedley_hint;
	UBYTE	hedley_hint2;
	ULONG	nreserved[4];
	LONG	*a2024_sync_raster;
	UWORD	control_delta_pal;
	UWORD	control_delta_ntsc;
	struct	MonitorSpec *current_monitor;
	struct	List MonitorList;
	struct	MonitorSpec *default_monitor;
	struct	SignalSemaphore *MonitorListSemaphore;
	VOID	*DisplayInfoDataBase;
	UWORD	TopLine;
	struct	SignalSemaphore *ActiViewCprSemaphore;
	ULONG	*UtilBase;		/* for hook and tag utilities. had to change because of name clash	*/
	ULONG	*ExecBase;		/* to link with rom.lib	*/
	UBYTE	*bwshifts;
	UWORD	*StrtFetchMasks;
	UWORD	*StopFetchMasks;
	UWORD	*Overrun;
	WORD	*RealStops;
	UWORD	SpriteWidth;	/* current width (in words) of sprites */
	UWORD	SpriteFMode;		/* current sprite fmode bits	*/
	BYTE	SoftSprites;	/* bit mask of size change knowledgeable sprites */
	BYTE	arraywidth;
	UWORD	DefaultSpriteWidth;	/* what width intuition wants */
	BYTE	SprMoveDisable;
	UBYTE	WantChips;
	UBYTE	BoardMemType;
	UBYTE	Bugs;
	ULONG	*gb_LayersBase;
	ULONG	ColorMask;
	APTR	IVector;
	APTR	IData;
	ULONG	SpecialCounter;		/* special for double buffering */
	APTR	DBList;
	UWORD	MonitorFlags;
	UBYTE	ScanDoubledSprites;
	UBYTE	BP3Bits;
	struct	AnalogSignalInterval MonitorVBlank;
	struct	MonitorSpec *natural_monitor;
	APTR	ProgData;
	UBYTE	ExtSprites;
	UBYTE	pad3;
	UWORD	GfxFlags;
	ULONG	VBCounter;
	struct	SignalSemaphore *HashTableSemaphore;
	ULONG	*HWEmul[9];

#define ChunkyToPlanarPtr HWEmul[0]

/* Values for GfxBase->DisplayFlags */
SET	NTSC,
		GENLOC,
		PAL,
		TODA_SAFE,
		REALLY_PAL,	
		 /* what is actual crystal frequency
			 (as opposed to what bootmenu set the agnus to)?
			 (V39) */
		LPEN_SWAP_FRAMES
				/* LightPen software could set this bit if the
				 * "lpen-with-interlace" fix put in for V39
				 * does not work. This is true of a number of
				 * Agnus chips.
				 * (V40).
				 */

CONST	BLITMSG_FAULT=4

/* bits defs for ChipRevBits */

FLAG	GFX_BIG_BLITS,
		GFX_HR_AGNUS=0,
		GFX_HR_DENISE,
		GFX_AA_ALICE,
		GFX_AA_LISA,
		GFX_AA_MLISA	/* internal use only */

/* Pass ONE of these to SetChipRev() */
#define SETCHIPREV_A	GFXF_HR_AGNUS
#define SETCHIPREV_ECS	(GFXF_HR_AGNUS | GFXF_HR_DENISE)
#define SETCHIPREV_AA	(GFXF_AA_ALICE | GFXF_AA_LISA | SETCHIPREV_ECS)
#define SETCHIPREV_BEST 0xffffffff

/* memory type */
CONST	BUS_16			=0,
		NML_CAS			=0,
		BUS_32			=1,
		DBL_CAS			=2,
		BANDWIDTH_1X	=BUS_16|NML_CAS,
		BANDWIDTH_2XNML=BUS_32,
		BANDWIDTH_2XDBL=DBL_CAS,
		BANDWIDTH_4X	=BUS_32|DBL_CAS

/* GfxFlags (private) */
CONST	NEW_DATABASE=1

#define GRAPHICSNAME	"graphics.library"
